conduit-extra-1.1.15: Batteries included conduit: adapters for common libraries.

Safe Haskell | None
Language | Haskell98

Data.Conduit.Zlib

Contents

- Conduits
- Flushing
- Decompression combinators
- Re-exported from zlib-bindings

Description

Streaming compression and decompression using conduits.

Parts of this code were taken from zlib-enum and adapted for conduits.

Synopsis

- compress :: (MonadBase base m, PrimMonad base, MonadThrow m) => Int -> WindowBits -> Conduit ByteString m ByteString
- decompress :: (MonadBase base m, PrimMonad base, MonadThrow m) => WindowBits -> Conduit ByteString m ByteString
- gzip :: (MonadThrow m, MonadBase base m, PrimMonad base) => Conduit ByteString m ByteString
- ungzip :: (MonadBase base m, PrimMonad base, MonadThrow m) => Conduit ByteString m ByteString
- compressFlush :: (MonadBase base m, PrimMonad base, MonadThrow m) => Int -> WindowBits -> Conduit (Flush ByteString) m (Flush ByteString)
- decompressFlush :: (MonadBase base m, PrimMonad base, MonadThrow m) => WindowBits -> Conduit (Flush ByteString) m (Flush ByteString)
- multiple :: Monad m => Conduit ByteString m a -> Conduit ByteString m a
- data WindowBits :: * = WindowBits Int
- defaultWindowBits :: WindowBits

# Conduits

compress #

Arguments

:: (MonadBase base m, PrimMonad base, MonadThrow m) |
=> Int | Compression level
-> WindowBits | Zlib parameter (see the zlib-bindings package as well as the zlib C library)
-> Conduit ByteString m ByteString |

Compress (deflate) a stream of `ByteString`s. The `WindowBits` also control the format (zlib vs. gzip).

decompress #

Arguments

:: (MonadBase base m, PrimMonad base, MonadThrow m) |
=> WindowBits | Zlib parameter (see the zlib-bindings package as well as the zlib C library)
-> Conduit ByteString m ByteString |

Decompress (inflate) a stream of `ByteString`s. For example:

       sourceFile "test.z" $= decompress defaultWindowBits $$ sinkFile "test"

gzip :: (MonadThrow m, MonadBase base m, PrimMonad base) => Conduit ByteString m ByteString #

Gzip compression with default parameters.

ungzip :: (MonadBase base m, PrimMonad base, MonadThrow m) => Conduit ByteString m ByteString #

Gzip decompression with default parameters.

# Flushing

compressFlush #

Arguments

:: (MonadBase base m, PrimMonad base, MonadThrow m) |
=> Int | Compression level
-> WindowBits | Zlib parameter (see the zlib-bindings package as well as the zlib C library)
-> Conduit (Flush ByteString) m (Flush ByteString) |

Same as `compress`, but allows you to explicitly flush the stream.

decompressFlush #

Arguments

:: (MonadBase base m, PrimMonad base, MonadThrow m) |
=> WindowBits | Zlib parameter (see the zlib-bindings package as well as the zlib C library)
-> Conduit (Flush ByteString) m (Flush ByteString) |

Same as `decompress`, but allows you to explicitly flush the stream.

# Decompression combinators

multiple :: Monad m => Conduit ByteString m a -> Conduit ByteString m a #

The standard `decompress` and `ungzip` functions will only decompress a single compressed entity from the stream. This combinator will exhaust the stream completely of all individual compressed entities. This is useful for cases where you have a concatenated archive, e.g. `cat file1.gz file2.gz > combined.gz`.

Usage:

    sourceFile "combined.gz" $$ multiple ungzip =$ consume

This combinator will not fail on an empty stream. If you want to ensure that at least one compressed entity in the stream exists, consider a usage such as:

    sourceFile "combined.gz" $$ (ungzip >> multiple ungzip) =$ consume

Since: 1.1.10

# Re-exported from zlib-bindings

data WindowBits :: * #

This specifies the size of the compression window. Larger values of this parameter result in better compression at the expense of higher memory usage.

The compression window size is the value of the the window bits raised to the power 2. The window bits must be in the range `8..15` which corresponds to compression window sizes of 256b to 32Kb. The default is 15 which is also the maximum size.

The total amount of memory used depends on the window bits and the `MemoryLevel`. See the `MemoryLevel` for the details.

Constructors

WindowBits Int |

Instances

Eq WindowBits |
Methods (==) :: WindowBits -> WindowBits -> Bool # (/=) :: WindowBits -> WindowBits -> Bool #
Ord WindowBits |
Methods compare :: WindowBits -> WindowBits -> Ordering # (<) :: WindowBits -> WindowBits -> Bool # (<=) :: WindowBits -> WindowBits -> Bool # (>) :: WindowBits -> WindowBits -> Bool # (>=) :: WindowBits -> WindowBits -> Bool # max :: WindowBits -> WindowBits -> WindowBits # min :: WindowBits -> WindowBits -> WindowBits #
Show WindowBits |
Methods showsPrec :: Int -> WindowBits -> ShowS # show :: WindowBits -> String # showList :: [WindowBits] -> ShowS #
Generic WindowBits |
Associated Types type Rep WindowBits :: * -> * # Methods from :: WindowBits -> Rep WindowBits x # to :: Rep WindowBits x -> WindowBits #
type Rep WindowBits |
type Rep WindowBits = D1 (MetaData "WindowBits" "Codec.Compression.Zlib.Stream" "zlib-0.6.1.2-1dMv6Gv8Q4W22Ei4thcEsU" False) ((:+:) (C1 (MetaCons "WindowBits" PrefixI False) (S1 (MetaSel (Nothing Symbol) NoSourceUnpackedness NoSourceStrictness DecidedLazy) (Rec0 Int))) (C1 (MetaCons "DefaultWindowBits" PrefixI False) U1))

defaultWindowBits :: WindowBits #

The default `WindowBits` is 15 which is also the maximum size.